# Copyright 1999-2005 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: $

inherit eutils games

DATA_VERSION=73

DESCRIPTION="orxonox is an open-source vertical scroller game programmed in C++, OpenGL, OpenAL and SDL"
HOMEPAGE="http://www.orxonox.net"
SRC_URI="http://www.orxonox.net/files/snapshots/${P}-${PR}.tar.bz2
         http://www.orxonox.net/files/snapshots/${PN}-data-r${DATA_VERSION}.tar.bz2"
LICENSE="GPL-2"
SLOT="0"
KEYWORDS="x86"
IUSE="gtk+-2"

DEPEND="virtual/opengl
        virtual/x11
        media-libs/openal
        media-libs/libsdl
        media-libs/sdl-image
        media-libs/sdl-ttf"

# Run-time dependencies, same as DEPEND if RDEPEND isn't defined:
#RDEPEND=""
S=${WORKDIR}/${P}

src_unpack() {
        unpack ${P}-${PR}.tar.bz2
        cd "${S}"
        unpack ${PN}-data-r${DATA_VERSION}.tar.bz2
}

src_compile() {
        egamesconf || die

        emake || die "emake failed"
}

src_install() {
        make DESTDIR=${D} install || die

        dodir ${GAMES_DATADIR}/${PN}
        cp -r data/* ${D}/${GAMES_DATADIR}/${PN}/ \
                || die "data copy failed"

        dodoc AUTHORS ChangeLog README

        prepgamesdirs

        #make \
        #       prefix=${D}/usr \
        #       mandir=${D}/usr/share/man \
        #       infodir=${D}/usr/share/info \
        #       libdir=${D}/usr/$(get_libdir) \
        #       install || die

        #einstall || die
}

pkg_postinst() {
        games_pkg_postinst
}
